/*****************************************************************************/
/* gtdk.c : Functions complmentaires aux objects standards gtk
 * gtdk.c : Additionals functions for standards objects
 *
 *
 * ToutDoux : Chtit gestionnaire de projet - A littl' project manager
 * Copyright (c) 2000-2001 Philippe Roy
 * Auteur - Author : Philippe Roy <ph_roy@toutdoux.org>
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

/*****************************************************************************/
/*** Arbre  collones - Ctree */
/*****************************************************************************/
gboolean gtdk_ctree_expand (GtkWidget *widget, GtkCTreeNode *node, GtkWidget *scrolledwindow);
void gtdk_ctree_clear (GtkWidget *widget);
GtkCTreeNode *gtdk_ctree_next (GtkCTreeNode *node);
int gtdk_ctree_optimal_column_width (GtkWidget *widget, int column);
void gtdk_ctree_invert_expand_recursive (GtkCTree *ctree, GtkCTreeNode *node);
GList *gtdk_ctree_read_node (GtkCTree *ctree, GtkCTreeNode *node);

/*****************************************************************************/
/*** Arbre - Tree */
/*****************************************************************************/
void gtdk_tree_item_set_label (GtkWidget *tree_item, gchar *data);

/*****************************************************************************/
/*** Liste  collones - Clist */
/*****************************************************************************/
int gtdk_clist_correction (GtkWidget *widget, int row, int bevent_y);
void gtdk_clist_adjustheight (GtkWidget *widget);

/*****************************************************************************/
/*** Fentre - Window */
/*****************************************************************************/
void gtdk_window_load_conf (gchar *name, GtkWidget *window);
void gtdk_window_save_conf (gchar *name, GtkWidget *window);
void gtdk_window_save_defaultconf (gchar *name, int xwindow, int ywindow);

/*****************************************************************************/
/*** Panneau - Paned */
/*****************************************************************************/
void gtdk_paned_load_conf (gchar *name, GtkWidget *paned);
void gtdk_paned_save_conf (gchar *name, GtkWidget *paned);
void gtdk_paned_save_defaultconf (gchar *name, int position);

/*****************************************************************************/
/*** Bote - Box */
/*****************************************************************************/
void gtdk_vbox_title (gchar *title, GtkWidget *vbox);

/*****************************************************************************/
/*** Entre+selecteur - Entry+selector */
/*****************************************************************************/
GtkWidget *gtdk_entry_file_selector (gchar *title, gchar *file , gchar *extension);
void gtdk_entry_file_selector_clicked (GtkButton *button, GList *data);
GtkWidget *gtdk_entry_date_selector (gchar *current);
void gtdk_entry_date_selector_clicked (GtkWidget *widget, GtkWidget *entry);
void gtdk_entry_date_selector_day_selected (GtkCalendar *calendar, GList *data);

/*****************************************************************************/
/*** Menu option - Option menu */
/*****************************************************************************/
void gtdk_option_menu_set_popdown_strings (GtkWidget *widget, GList *data, GtkWidget *widget_dest);
void gtdk_option_menu_activate (GtkWidget *menuitem, GList *data);
GtkWidget *gtdk_entry_option_menu_new (void);
void gtdk_entry_option_menu_set_popdown_strings (GtkWidget *widget, GList *data);

/*****************************************************************************/
/*** Item de menu - Menu item */
/*****************************************************************************/
GtkWidget *gtdk_menu_item_new (gchar *text, gchar *dir, gchar *file);
GtkWidget *gtdk_menu_item_accel_new (gchar *text, gchar *dir, gchar *file, GtkAccelGroup *accel_group, guint accel_key, guint accel_mods);
void gtdk_menu_item_add_accelerator (GtkWidget *widget, guint accel_signal_id, GtkAccelGroup *accel_group, guint accel_key, GdkModifierType accel_mods, GtkAccelFlags accel_flags, GtkWidget *label_accel);
void gtdk_menu_item_remove_accelerator (GtkWidget *widget, GtkAccelGroup *accel_group, guint accel_key, GdkModifierType  accel_mods, GtkWidget *label_accel);
void gtdk_menu_item_set_submenu (GtkMenuItem *menuitem, GtkWidget *menu);

/*****************************************************************************/
/*** Types spcifiques de GDK/GTK+ - Specific types of GDK/GTK+ */
/*****************************************************************************/
GtkAnchorType gtdk_anchor_parse (gchar *value);
GtkJustification gtdk_justification_parse (gchar *value);
GdkLineStyle gtdk_linestyle_parse (gchar *value);
GdkCapStyle gtdk_cap_parse (gchar *value);
GdkJoinStyle gtdk_join_parse (gchar *value);
GdkColor gtdk_color_invert (GdkColor color);
GdkColor gtdk_color_parse (gchar *value);
GdkCursor *gtdk_cursor (const gchar *cursor_source, const gchar *cursor_mask);
GdkFont *gtdk_widget_get_default_font (void);

/*****************************************************************************/
/*** Cavenas - Canvas */
/*****************************************************************************/
void gtdk_canvas_clear (GnomeCanvas *canvas);
void gtdk_canvas_link (GnomeCanvasItem *item, GnomeCanvasItem *line, GnomeCanvasItem *arrow);
void gtdk_canvas_link_xy (double item_x1w, double item_y1w, double item_x2w, double item_y2w, double line_x1, double line_y1, double line_x2, double line_y2, GnomeCanvasItem *arrow);
double gtdk_canvas_w2c_x (double x);
double gtdk_canvas_w2i_x (GnomeCanvasItem *item, double x);
double gtdk_canvas_i2w_x (GnomeCanvasItem *item, double x);
double gtdk_canvas_c2w_x (GnomeCanvas *canvas, double x);

/*****************************************************************************/
/*** Calendrier - Calendar */
/*****************************************************************************/
void gtdk_calendar_select_date (GtkCalendar *calendar, GDate *date);
GDate *gtdk_calendar_get_date (GtkCalendar *calendar);

/*****************************************************************************/
/*** Barre d'outils - Toolbar */
/*****************************************************************************/
GtkWidget *gtdk_toolbar_append_button (GtkToolbar *toolbar, gchar *text, gchar *icon_file);
GtkWidget *gtdk_toolbar_append_button_stock (GtkToolbar *toolbar, gchar *text, GtkWidget *window, gchar *icon);
GtkWidget *gtdk_toolbar_append_togglebutton (GtkToolbar *toolbar, gchar *text, gchar *icon_file);
GtkWidget *gtdk_toolbar_append_togglebutton_stock (GtkToolbar *toolbar, gchar *text, GtkWidget *window, gchar *icon);
GtkWidget *gtdk_toolbar_append_radiobutton (GtkToolbar *toolbar, GtkWidget *sibling, gchar *text, gchar *icon_file);
GtkWidget *gtdk_toolbar_append_radiobutton_stock (GtkToolbar *toolbar, GtkWidget *sibling, gchar *text, GtkWidget *window, gchar *icon);
