/*****************************************************************************/
/* td_mod_editprop.h : Objet Gtk+
 * td_mod_editprop.h : Gtk+ object
 *
 *
 * ToutDoux : Chtit gestionnaire de projet - A littl' project manager
 * Copyright (c) 2000-2001 Philippe Roy
 * Auteur - Author : Philippe Roy <ph_roy@toutdoux.org>
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

/*****************************************************************************/
/*** Macros */
/*****************************************************************************/
#define TD_TYPE_MOD_EDITPROP (td_mod_editprop_get_type ())
#define TD_MOD_EDITPROP(obj) (GTK_CHECK_CAST ((obj), TD_TYPE_MOD_EDITPROP, TdModEditprop))
#define TD_MOD_EDITPROP_CLASS(klass) (GTK_CHECK_CLASS_CASTS ((klass), TD_TYPE_MOD_EDITPROP, TdModEditpropClass))
#define TD_IS_MOD_EDITPROP(obj) (GTK_CHECK_TYPE ((obj), TD_TYPE_MOD_EDITPROP))
#define TD_IS_MOD_EDITPROP_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), TD_TYPE_MOD_EDITPROP))

/*****************************************************************************/
/*** Structure */
/*****************************************************************************/
typedef struct _TdModEditprop TdModEditprop;
typedef struct _TdModEditpropClass TdModEditpropClass;

struct _TdModEditprop
{
  /*< public >*/
  GtkObject object;
  gchar *name; /*** Nom - Name */
  gchar *name_intl; /*** Nom international - International name */
  gchar *type; /*** Type */
  GtkWidget *label; /*** Etiquette - Label */
  GtkWidget *widget; /*** Widget */
  gchar *widget_data1; /*** Donne complmentaire 1 - Complementary data 1 */
  gchar *widget_data2; /*** Donne complmentaire 2 - Complementary data 2 */
  GtkWidget *widget_parent; /*** Container du widget - Container of widget */
  GtkWidget *widget_list; /*** Liste - List */
  gchar *query_refresh; /*** Requte de rafrachissement - Query of refresh */
  gchar *query_visible; /*** Requte de visibilit - Query of visisbility */
  gchar *query_unsensitive; /*** Requte de sensibilit - Query of sensitivity */
  gchar *query_list; /*** Requte de liste - Query of list */
  GtkObject *dico; /*** Dictionnaire - Dictionary */
};

struct _TdModEditpropClass
{
  GtkObjectClass parent_class;
  void (*set_widget) (TdModEditprop *mod_editprop, GtkWidget *widget, GtkWidget *widget_parent);
  void (*set_dico) (TdModEditprop *db_mod_editprop, GtkObject *dico);
};

/*****************************************************************************/
/*** Arguments */
/*****************************************************************************/
void td_mod_editprop_set_name (TdModEditprop *mod_editprop, gchar *name);
void td_mod_editprop_set_name_intl (TdModEditprop *mod_editprop, gchar *name_intl);
void td_mod_editprop_set_widget_data1 (TdModEditprop *mod_editprop, gchar *widget_data1);
void td_mod_editprop_set_widget_data2 (TdModEditprop *mod_editprop, gchar *widget_data2);
void td_mod_editprop_set_name (TdModEditprop *mod_editprop, gchar *name);
void td_mod_editprop_set_query_refresh (TdModEditprop *mod_editprop, gchar *query_refresh);
void td_mod_editprop_set_query_visible (TdModEditprop *mod_editprop, gchar *query_visible);
void td_mod_editprop_set_query_unsensitive (TdModEditprop *mod_editprop, gchar *query_unsensitive);
void td_mod_editprop_set_query_list (TdModEditprop *mod_editprop, gchar *query_list);
static void td_mod_editprop_set_arg (GtkObject *object, GtkArg *arg, guint arg_id);
static void td_mod_editprop_get_arg (GtkObject *object, GtkArg *arg, guint arg_id);

/*****************************************************************************/
/*** Initialisation */
/*****************************************************************************/
static void td_mod_editprop_init (TdModEditprop *mod_editprop);
static void td_mod_editprop_class_init (TdModEditpropClass *klass);
GtkType td_mod_editprop_get_type (void);
GtkObject *td_mod_editprop_new (void);

/*****************************************************************************/
/*** Affectations - Allocations */
/*****************************************************************************/
void td_mod_editprop_set_widget (TdModEditprop *mod_editprop, GtkWidget *widget, GtkWidget *widget_parent);
void td_mod_editprop_set_widget_list (TdModEditprop *mod_editprop, GtkWidget *widget_list);
void td_mod_editprop_set_dico (TdModEditprop *mod_editprop, GtkObject *dico);
